import os
from typing import Optional


class File:
    def __init__(self, file_path: str = "/path/to/file.fits", new_dir=None):
        self.file_path = file_path
        self.dirname = os.path.dirname(self.file_path)
        self.file_name = os.path.basename(self.file_path)
        self.prefix, self.ext = os.path.splitext(self.file_name)
        self.new_dir = new_dir if new_dir is not None else self.dirname

    def replace_ext(
        self, new_ext: Optional[str] = "img.fits", new_dir: Optional[str] = None
    ) -> str:
        if new_dir is None:
            new_dir = self.new_dir
        if new_ext is None:
            new_ext = self.ext

        if new_ext.startswith("."):
            return os.path.join(new_dir, self.prefix + new_ext)
        else:
            return os.path.join(new_dir, self.prefix + "_" + new_ext)
